#include <stdio.h>

#define MAX 100000

int n, m;

typedef struct way {
	int src;
	int dst;
	int len;
    long long depth;
} way;

way ways[2*MAX];
way *city[MAX];
int count[MAX] = {0};
int visited[MAX] = {0};

int cmp(way *x, way *y) {
 	return x->src - y->src;
}

long long find_max(int v, int dst) {
 	int i;
 	long long max = 0;

    for (i=0; i<count[v]; i++) {
        if (city[v][i].dst != dst && city[v][i].depth > max) {
         	max = city[v][i].depth;
        }
    }

    return max;
}

long long deepness(int v) {
    int i;
    long long max = 0;

    visited[v] = 1;

    for (i=0; i<count[v]; i++) {
    	if (visited[city[v][i].dst]) continue;

		city[v][i].depth = city[v][i].len + deepness(city[v][i].dst);
		if (max < city[v][i].depth) max = city[v][i].depth;
    }

    return max;
}

long long deep2(int v, long long deep) {
	int i;
	long long d;

	visited[v] = 1;

    for (i=0; i<count[v]; i++) {
    	if (city[v][i].depth == 0) city[v][i].depth = deep;
    }

    for (i=0; i<count[v]; i++) {
    	if (visited[city[v][i].dst]) continue;

		d = find_max(v, city[v][i].dst);
		deep2(city[v][i].dst, d + city[v][i].len);
    }

	return 0;
}
int main() {

	int i, j;
    int a, b, c;
    long long max;

    /****/
//    freopen("paths.in", "rt", stdin);
    /****/

	scanf("%d %d", &n, &m);
    for (i=0; i<m; i++) {
        scanf("%d %d %d", &a, &b, &c);

		ways[i].src = a;
        ways[i].dst = b;
        ways[i].len = c;
        ways[i].depth = 0;

        ways[m+i].src = b;
        ways[m+i].dst = a;
        ways[m+i].len = c;
        ways[m+i].depth = 0;

        count[a]++;
        count[b]++;
    }

    qsort(ways, 2*m, sizeof(way), cmp);

    for (i=1, j=0; i<=n; i++) {

		city[i] = &ways[j];
        while (ways[j].src == i) {
        	j++;
        }
    }

    deepness(1);

    memset(visited, 0, sizeof(visited));
    deep2(1, 0);

    for (i=1; i<=n; i++) {
        max = 0;

        for (j=0; j<count[i]; j++) {
         	if (city[i][j].depth > max) max =city[i][j].depth;
        }

        printf("%Ld\n", max);
    }

    fclose(stdin);
    fclose(stdout);

	return 0;
}
