program paths;

const
	MAXN				= 1000;
	INF				= 10000000;

type
	Integer				= LongInt;

var
	G				: Array [1 .. MAXN, 1 .. MAXN] of Integer;
	N, M				: Integer;
	sol				: Array [1 .. MAXN] of Integer;
	F				: Array [1 .. MAXN] of Integer;
	used				: Array [1 .. MAXN] of Boolean;
	a, b, c				: Integer;
	i, j				: Integer;

procedure readInput;
begin
	readln(N, M);
	for i := 1 to N do
		for j := 1 to N do
			G[i, j] := INF;
	for i := 1 to M do begin
		readln(a, b, c);
		G[a, b] := c;
		G[b, a] := c;
	end;
end;

procedure writeOutput;
begin
	for i := 1 to N do
		writeln(sol[i]);
end;

procedure dijkstra(c: Integer);
var
	i, j, min, mini			: Integer;
	ed				: Integer;
begin
	for i := 1 to N do begin
		F[i] := G[c, i];
		used[i] := False;
	end;
	ed := c;
	for i := 1 to N do begin
		used[ed] := True;
		for j := 1 to N do
			if (not used[j]) and (F[j] > F[ed] + G[ed, j]) then
				F[j] := F[ed] + G[ed, j];
		min := INF + 1;
		for j := 1 to N do
			if (not used[j]) and (min > F[j]) then begin
				min := F[j];
				mini := j;
			end;
		ed := mini;
	end;
	used[ed] := True;
	for j := 1 to N do
		if (not used[j]) and (F[j] > F[ed] + G[ed, j]) then
			F[j] := F[ed] + G[ed, j];
	min := INF + 1;
	for j := 1 to N do
		if (not used[j]) and (min > F[j]) then begin
			min := F[j];
			mini := j;
		end;
	ed := mini;
	sol[c] := -1;
        for j := 1 to N do
        	if (j <> c) and (F[j] > sol[c]) then
                	sol[c] := F[j];
end;

procedure Solve;
begin
	for i := 1 to N do
		dijkstra(i);
end;

begin
	readInput;
	Solve;
	writeOutput;
end.