#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>

#define MAXN 10
#define MAXK 10

int k,n;

struct _SNode
  {
    struct _SNode *next[MAXK + 1];
    short nasl;
  };

typedef struct _SNode SNode;


SNode *root;

short curr[MAXN];
int steps = 0;

int maxs = 0;
int TIME_LIMIT = (CLOCKS_PER_SEC*28) / 10;

char back[50000][2];
char opt [50000][2];

void Output();

// Adds the current configuration
void AddConf()
  {
    SNode *c = root;
    int i = 0;

//    printf("AddConf\n");
    for (i = 0;i < n;i++)
      {
        if (!c->next[curr[i]])
          {
            c->next[curr[i]] = (SNode*)malloc(sizeof(SNode));
            if (c->next[curr[i]] == 0) Output();

            memset(c->next[curr[i]],0,sizeof(SNode));
            c->next[curr[i]]->nasl = 0;
            c->nasl++;
          }
        c = c->next[curr[i]];
      }
  }

// Check whether the current configuration is used
int UsedConf()
  {
    SNode *c = root;
    int i;

//    printf("UsedCondf\n");
    if (c == NULL)
      {
        Output();
      }
    for (i = 0;i < n;i++)
      {
        if (curr[i] > k || curr[i] < 0) Output();

        if (!c->next[curr[i]]) return 0;
        c = c->next[curr[i]];
      }
//    printf("Finished\n");
    return 1;
  }

int Remove(SNode *node,int ind)
  {
//    printf("Remove\n");
    if (ind == n) return 1;
    if (Remove(node->next[curr[ind]],ind + 1))
      {
        free(node->next[curr[ind]]);
        node->next[curr[ind]] = NULL;
        node->nasl--;
      }
    if (node->nasl == 0) return 1;
    return 0;
  }

void RemoveConf()
  {
    Remove(root,0);
  }

void RemoveAll(SNode *node)
  {
    int i;
    for (i = 0;i <= k;i++)
      if (node->next[i])

        {
          RemoveAll(node->next[i]);
          free(node->next[i]);
          node->next[i] = NULL;
        }

  }

void Init()
  {
    int i;

//    freopen("cups.in","rt",stdin);
    scanf("%d%d",&n,&k);

    root = (SNode*)malloc(sizeof(SNode));
    memset(root,0,sizeof(SNode));
  }

void Output()
  {
    int i;
    printf("%d\n",maxs);
/*    memset(curr,0,sizeof(curr));
    curr[0] = k;*/
    RemoveAll(root);
/*    for (j = 0;j < n;j++)
      printf("%d ",curr[j]);
    printf("\n");*/
    for (i = 0;i < maxs;i++)
      {
        curr[opt[i][0]]--;
        curr[opt[i][1]]++;
        printf("%d %d\n",opt[i][0] + 1,opt[i][1] + 1);

//        printf("%d %d ->",opt[i][0] + 1,opt[i][1] + 1);
//        for (j = 0;j < n;j++)
//          printf("%d ",curr[j]);
//        printf("\n");
      }
    exit(0);
  }

void rec()
  {
    char i,j;

//    printf("Rec\n");
    if (clock() > TIME_LIMIT) Output();

    for (i = 0;i < n;i++)
      if (curr[i])
        for (j = 0;j < n;j++)
          if (i != j)
            {
              curr[i]--;
              curr[j]++;
              back[steps][0] = i;
              back[steps][1] = j;

              if (!UsedConf())
                {
                  steps++;
                  if (steps > maxs)
                    {
//                      printf("");

                      maxs = steps;
                      memcpy(opt,back,sizeof(opt));
//                      if (maxs % 1000 == 0) printf("Found %d\n",maxs);
                    }

                  AddConf();
                  rec();
                  RemoveConf();

                  steps--;
                }
              curr[i]++;
              curr[j]--;
            }
  }

void Solve()
  {
    memset(&curr,0,sizeof(curr));
    curr[0] = k;
    AddConf();

    rec();
  }

int main()
  {
    clock();
    Init();
    Solve();
    Output();
    return 0;
  }