#include <stdio.h>
#include <stdlib.h>

#define N	131072

struct es {
	int v1;
        int v2;
        long long c;
} e[2*N];
int nn, mm;

int nb[N];
int nc[N];
int v[N];
long long td[N];
long long d[N];
int q[N];
int qb, qe;

int cmpe(const void *a, const void *b) {
	if (((struct es*)a)->v1 == ((struct es*)b)->v1)
        	return ((struct es*)a)->v2 - ((struct es*)b)->v2;
        return ((struct es*)a)->v1 - ((struct es*)b)->v1;
}

void read_data() {
	int i, j;
        int t1, t2, tc;

        scanf("%d%d", &nn, &mm);

        if (nn-1 != mm) {
                printf("Input not a tree\n");
                exit(1);
        }

        for (i = 0; i < mm; i++) {
        	scanf("%d%d%d", &t1, &t2, &tc);
                e[2*i].v1 = t1; e[2*i].v2 = t2; e[2*i].c = tc;
                e[2*i+1].v1 = t2; e[2*i+1].v2 = t1; e[2*i+1].c = tc;
        }

        qsort(e, 2*mm, sizeof(struct es), cmpe);

        j = 0;
        for (i = 1; i <= nn; i++) {
		nb[i] = j;
                while (e[j].v1 == i) {
                	nc[i]++;
                        j++;
                }
        }
}

long long bfs(int n, int p) {
	int c;
        int i;
        long long mds;

	qb = qe = 0;
        for (i = 0; i <= nn; i++) {
                v[i] = 0;
                td[i] = 0;
        }

        q[qe++] = n;
        mds = 0;
        v[p] = 1;
        v[n] = 1;
        while (qb < qe) {
        	c = q[qb++];
                if (td[c] > mds)
                        mds = td[c];
                for (i = nb[c]; i < nb[c] + nc[c]; i++)
                        if (v[e[i].v2] == 0) {
                                v[e[i].v2] = 1;
                                q[qe++] = e[i].v2;
                                td[e[i].v2] = td[c] + e[i].c;
                        }
        }
        return mds;
}

void update_dist(int n, int p, long long ds) {
	int c;
        int i;

	qb = qe = 0;
        for (i = 0; i <= nn; i++)
                v[i] = 0;

        d[n] = ds;
        q[qe++] = n;
        v[p] = 1;
        v[n] = 1;
        while (qb < qe) {
        	c = q[qb++];
                for (i = nb[c]; i < nb[c] + nc[c]; i++)
                        if (v[e[i].v2] == 0) {
                                v[e[i].v2] = 1;
                                q[qe++] = e[i].v2;
                                d[e[i].v2] = d[c] + e[i].c;
                        }
        }
}

void find_dist(int n, int p, int pd2) {
	int i;
        long long md, md2, tmpd;
        int mc;
        int c;

        md = md2 = 0;

        for (i = nb[n]; i < nb[n] + nc[n]; i++) {
                if (e[i].v2 == p)
                	continue;
                tmpd = bfs(e[i].v2, n) + e[i].c;
                if (tmpd > md) {
                	md2 = md;
                        md = tmpd;
                        mc = i;
                } else if (tmpd > md2)
                	md2 = tmpd;
        }
        if (pd2 > md) {
        	d[n] = pd2;
                for (i = nb[n]; i < nb[n] + nc[n]; i++) {
                        if (e[i].v2 == p)
                        	continue;
                        update_dist(e[i].v2, n, pd2+e[i].c);
                }
                return;
        }

        d[n] = md;
        for (i = nb[n]; i < nb[n] + nc[n]; i++) {
                if ((e[i].v2 == p) || (i == mc))
                	continue;
                update_dist(e[i].v2, n, md+e[i].c);
        }
        if (pd2 < md2)
        	pd2 = md2;

        c = e[mc].v2;
        while (nc[c] == 1) {
                pd2 += e[mc].c;
                md -= e[mc].c;
                if (pd2 > md) {
                        d[c] = pd2;
                        for (i = nb[n]; i < nb[n] + nc[n]; i++) {
                                if (d[e[i].v2] != 0)
                                        continue;
                                update_dist(e[i].v2, n, pd2+e[i].c);
                        }
                        return;
                } else
                        d[c] = md;

                mc = nb[n];
                c = e[mc].v2;
        }

        find_dist(e[mc].v2, n, pd2+e[mc].c);
}

int main() {
	int i;

	read_data();
        find_dist(1, 0, 0);
        for (i = 1; i <= nn; i++)
        	printf("%lld\n", d[i]);

        return 0;
}
