#include <stdio.h>
#include <vector>
using namespace std;

const int UNKNOWN = -2;
const int N = 100105;

struct TDist{
	long long up, down;
};

struct Type{
	Type(){}
  Type(int _num, long long _dist){
   	num = _num;
    dist = _dist;
  }
 	int num;
  long long dist;
};

vector<Type> a[N];
Type prev[N];
TDist dist[N];

int i, n, m;

void Input(){

//	freopen("paths3.in", "rt" ,stdin);

	scanf("%d%d", &n, &m);
	for(i=1; i<=m; i++){
  	int p, q;
  	long long dist;

  	scanf("%d%d%lld", &p, &q, &dist);

    a[p].push_back(Type(q, dist));
    a[q].push_back(Type(p, dist));

  }
}

void Init(int node){
	for(int i=0; i<a[node].size(); i++)
  	if(prev[a[node][i].num].num == 0){
    	prev[a[node][i].num].num = node;
      prev[a[node][i].num].dist = a[node][i].dist;
      Init(a[node][i].num);
    }
}

long long max(long long p, long long q){
	return p > q ? p : q;
}


long long CountDown(int node){

  if(dist[node].down != UNKNOWN)
  	return dist[node].down;

  bool do_something = false;

  for(int i=0; i<a[node].size(); i++)
  	if(a[node][i].num != prev[node].num){

 			do_something = true;
	    dist[node].down = max(dist[node].down,
	    	a[node][i].dist + CountDown(a[node][i].num));

    }
  if(!do_something){
  	dist[node].down = 0;
  }

	return dist[node].down;
}


long long CountUp(int node){

	if(dist[node].up != UNKNOWN)
  	return dist[node].up;

  if(prev[node].num != UNKNOWN){

    int last = prev[node].num;
    dist[node].up = prev[node].dist + CountUp(last);

    for(int i=0; i<a[last].size(); i++)
    	if(a[last][i].num != node && a[last][i].num != prev[last].num){

      	dist[node].up = max(dist[node].up,
      		prev[node].dist + a[last][i].dist + CountDown(a[last][i].num));

    	}
  }
  else{
  	dist[node].up = 0;
  }

  return dist[node].up;

}


void Solve(){

	prev[1].num = UNKNOWN;

	Init(1);

  for(i=1; i<=n; i++){
  	dist[i].up = UNKNOWN;
    dist[i].down = UNKNOWN;
  }

  for(i=1; i<=n; i++)
  	CountDown(i);
  for(i=1; i<=n; i++)
		CountUp(i);


  //freopen("paths.out", "wt", stdout);

  for(i=1; i<=n; i++)
  	printf("%lld\n", max(dist[i].up, dist[i].down));
}

int main(){
	Input();
  Solve();

	return 0;
}


