#include <stdio.h>
#include <stdlib.h>

#define MAXN 100002

#define max(a, b) (a) > (b) ? (a) : (b)

struct road {
  long source, dest, len;
};

long M, N, c, s, max1, max2, tmp, *dists1, *dists2;
long i, j, m;
road *paths;

int cmp(const void *a, const void *b)
{
  if(((road *)a)->source < ((road *)b)->source)
	return -1;
  if(((road *)a)->source > ((road *)b)->source)
	return 1;
  return 0;
}

long ff(long a)
{
  for(i = 0, j = s - 1; i <= j;)
  {
	m = (i+j)/2;
	if(a < paths[m].source)
	  j = m-1;
	else
	  if(a > paths[m].source)
		i = m+1;
	  else
	  {
		while(paths[m].source == a && m > 1)
		  m--;
		if(paths[m].source == a)
		  return m;
		else
		  return m+1;
	  }
  }
  return 0;
}

void findfar(long r, long prev)
{
  long sp;
  sp = ff(r);
  for(; paths[sp].source == r; sp++)
	if(paths[sp].dest != prev)
	{
	  dists1[paths[sp].dest] = dists1[r] + paths[sp].len;
	  findfar(paths[sp].dest, r);
	}
}

void findfar2(long r, long prev)
{
  long sp;
  sp = ff(r);
  for(; paths[sp].source == r; sp++)
	if(paths[sp].dest != prev)
	{
	  dists2[paths[sp].dest] = dists2[r] + paths[sp].len;
	  findfar2(paths[sp].dest, r);
	}
}

int main(void)
{
  paths = new road[MAXN];
  dists1 = new long[MAXN];
  dists2 = new long[MAXN];
  scanf("%ld %ld", &N, &M);
  for(c = 0, s = 2*M; c < s; c += 2)
  {
	scanf("%ld %ld %ld", &paths[c].source, &paths[c].dest, &paths[c].len);
	paths[c+1].source = paths[c].dest;
	paths[c+1].dest = paths[c].source;
	paths[c+1].len = paths[c].len;
  }
  qsort(paths, s, sizeof(road), cmp);
  dists1[1] = 0;
  findfar(1, 0);
  for(max1 = 1, c = 2; c < s; c++)
	if(dists1[c] > dists1[max1])
	  max1 = c;
  dists1[max1] = 0;
  findfar(max1, 0);
  for(max2 = 1, c = 2; c < s; c++)
	if(dists1[c] > dists1[max2])
	  max2 = c;
  dists2[max2] = 0;
  findfar2(max2, 0);
  for(c = 1; c <= N; c++)
	printf("%ld\n", max(dists1[c], dists2[c]));
  return 0;
}

























