#include <stdio.h>

#define maxN 1500
#define accr 0.0000001
double maxC=1500000;

struct Kartina { double H,W; } K[maxN+1];
double D[maxN+1][maxN+1],F[maxN+1];
float MaxEl[maxN+1][maxN+1];
double W;
int N;

void init();
int equal(double fst,double snd);
int less(double fst,double snd);
double MIN(double fst,double snd);
double MAX(double fst,double snd);

double calc(int from,int to,double Cw)
{
 double c1=maxC,c2=maxC;
 if (from>to) return 0;
 if (less(Cw+K[from].W,W)) {
	  c1=calc(from+1,to,Cw+K[from].W);
	  c1=MAX(K[from].H,c1); }
 if (less(Cw+K[from].H,W)) {
	  c2=calc(from+1,to,Cw+K[from].H);
	  c2=MAX(K[from].W,c2); }
 return MIN(c1,c2);
}

int main()
{
 init();
 int i,j;
 for (i=1;i<=N;i++)
	for (j=i;j<=N;j++)
	   if (equal(D[i][j],-1)) D[i][j]=calc(i,j,0);
 for (i=1;i<=N;i++)
	for (j=1,F[i]=maxC;j<=i;j++)
		F[i]=MIN(F[i],F[j-1]+D[j][i]);
 printf("%.6lf\n",F[N]);
 return 0;
}

void init()
{
 double MinSum[maxN+1],MaxSum[maxN+1],max;
 int bci,bcj;
 MinSum[0]=0;
 MaxSum[0]=0;
 scanf("%d%lf",&N,&W);
 for (bci=1;bci<=N;bci++) {
	 scanf("%lf%lf",&K[bci].H,&K[bci].W);
	 MinSum[bci]=MinSum[bci-1]+MIN(K[bci].H,K[bci].W);
	 MaxSum[bci]=MaxSum[bci-1]+MAX(K[bci].H,K[bci].W); }
 for (bci=1;bci<=N;bci++)
	 for (max=0,bcj=bci;bcj<=N;MaxEl[bci][bcj++]=max)
		 if (MIN(K[bcj].H,K[bcj].W)>max) max=MIN(K[bcj].H,K[bcj].W);

 for (bci=1;bci<=N;bci++)
	for (bcj=bci;bcj<=N;bcj++)
		if (less(W+accr*2,MinSum[bcj]-MinSum[bci-1])) D[bci][bcj]=maxC;
		   else if (less(W+accr*2,MaxSum[bcj]-MaxSum[bci-1])) D[bci][bcj]=-1;
			  else D[bci][bcj]=MaxEl[bci][bcj];
}

int equal(double fst,double snd)
{
 if (fst-snd<accr&&fst-snd>-accr) return 1;
 return 0;
}

int less(double fst,double snd)
{
 if (fst<accr+snd) return 1;
 return 0;
}

double MIN(double fst,double snd)
{
 if (fst<snd) return fst;
 return snd;
}
double MAX(double fst,double snd)
{
 if (fst>snd) return fst;
 return snd;
}