#include <stdio.h>

const int N = 1700;
const double inf = 102345678.0;
const double eps = 0.00000001;
const double WEI = 1000.0;

struct Type{
	double a, b;
};

struct SaveRes{
	int best;
  double h;
};

Type data[N];
int n;
double w;
SaveRes res[N];


void swap(double &p, double &q){
	double z = p; p = q; q = z;
}

void Input(){
  //freopen("pict2.in", "rt", stdin);
  scanf("%d%lf", &n, &w);
  for(int i=1; i<=n; i++){
  	scanf("%lf%lf", &data[i].a, &data[i].b);
		if(data[i].a > data[i].b)
  		swap(data[i].a, data[i].b);
  }
  n++;
  data[n].a = w;
  data[n].b = w;
}

long double min(double p, double q){
	return p < q ? p : q;
}

bool Check(int p, int q, double wei){

	double ost = w;
  for(int i=p; i<=q; i++){

    if(data[i].a > wei)
    	return false;


  	if(data[i].b <= wei){
    	ost -= data[i].a;
    }
    else{
    	ost -= data[i].b;
    }
  }
  if(ost > -eps)
  	return true;
  else
  	return false;
}


double Can(int p, int q){

	double sum = 0;
  for(int k=p; k<=q; k++)
  	sum += data[k].a;

  if(sum > w)
  	return -1;

	double min = 0.0;
  double max = WEI;
  double mid;

  while((max - min) > eps){
  	mid = (min + max) / 2.0;

    if(Check(p, q, mid)){
    	max = mid;
    }
    else{
    	min = mid;
    }
  }

  return mid;

}


void Solve(){
	int i, j;

	for(i=1; i<=n; i++){
    res[i].h = inf;
    res[i].best = 0;
  }
	res[0].h = 0.0;
  res[1].best = 0;
  res[1].h = 0.0;

  for(i=2; i<=n; i++)
  	for(j=res[i-1].best; j<i; j++){

  		double up = Can(j,i-1);
      if(up > 0){
      	if(res[i].h > res[j].h + up){
        	res[i].h = res[j].h + up;
          res[i].best = j;
        }
	    	//Hei[i] = min(Hei[i], Hei[j] + up);
      }

		}
  /*
	for(i=1; i<=n; i++)
  	printf("%d -> %.6lf\n", i, Hei[i]);
  */
}

int main(){
	Input();
  Solve();
  printf("%.6lf\n", res[n].h);

	return 0;
}
