#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define N 1600
#define eps 10e-7
#define zero(x) ( fabs(x)<eps?1:0 )
#define inf 10e8

struct ps {
        double a;
        double b;
} p[N];

int n;
double w;
double mh[N][N];
double bh[N];
struct ps tmp[N];

int cmpp(const void *a, const void *b) {
        if (zero(((struct ps*)a)->b - ((struct ps*)b)->b))
                return ((struct ps *)b)->a - ((struct ps *)a)->a;

        return ((struct ps *)b)->b - ((struct ps *)a)->b;
}

void calc(int l, int r) {
        int i;
        double cw;
        double ch;
        double och;

        cw = 0.0;
        ch = 0.0;
        for (i = 0; i <= r-l; i++) {
                tmp[i].a = p[i+l].a;
                tmp[i].b = p[i+l].b;
                cw += tmp[i].a;
        }
        if (cw > w - eps)
                return;

        och = 0.0;
        qsort(tmp, r-l+1, sizeof(struct ps), cmpp);
        for (i = 0; i <= r-l; i++) {
                if (och > tmp[i].b - eps)
                        break;
                if (tmp[i].b - tmp[i].a < w - cw + eps) {
                        cw += tmp[i].b - tmp[i].a;
                        if (tmp[i].a > och - eps)
                                och = tmp[i].a;

                } else {
                        och = tmp[i].b;
                        break;
                }
        }
        mh[l][r] = och;
        //printf("mh[%d][%d] = %.6lf\n", l, r, mh[l][r]);
}

void solve() {
        int i, j;

        for (i = 0; i <= n; i++) {
                bh[i] = inf + 1;
                for (j = 0; j <= n; j++)
                        mh[i][j] = inf+1;
        }
        bh[0] = 0.0;

        for (i = 1; i <= n; i++) {
                if (p[i].b < w + eps)
                        mh[i][i] = p[i].a;
                else
                        mh[i][i] = p[i].b;

                for (j = i+1; j <= n; j++) {
                        if (mh[i][j-1] > inf)
                                break;
                        calc(i, j);
                        //printf("bh[%d] = %.6lf\n", j, bh[j]);
                        //printf("bh[%d] = %.6lf\n", i-1, bh[i-1]);
                        //printf("mh[%d][%d] = %.6lf\n", i, j, mh[i][j]);
                        if (bh[j] > bh[i-1] + mh[i][j] - eps)
                                bh[j] = bh[i-1] + mh[i][j];
                        //printf("bh[%d] = %.6lf\n", j, bh[j]);
                }
        }
        printf("%.6lf\n", bh[n]);
}

int main() {
        int i;
        double t;

        scanf("%d%lf", &n, &w);
        for (i = 1; i <= n; i++) {
                scanf("%lf%lf", &p[i].a, &p[i].b);
                if (p[i].a > p[i].b) {
                        t = p[i].a;
                        p[i].a = p[i].b;
                        p[i].b = t;
                }
        }

        solve();
        return 0;
}
